/* (VC)Loe Feijs and TU/e 2011-2016 */
/* tool to sample esher style line fragments */
/* replace karl by any bird, fish, boat or unicorn */
/* when done, copy commands from console message window */
/* image karl, source: karl.staging.vellance.net/wp-content/themes/karl-2014 */

import nl.tue.id.oogway.*;

int XSIZE=1280;
int YSIZE=960;
Oogway o;
PImage b;

void setup(){
  size(XSIZE,YSIZE);
  background(51);
  b = loadImage("karl.jpg");
  image(b, 0, 0);
  stroke(0,255,0);
  o = new Oogway(this);
  o.penDown();
  o.setPenColor(255, 0, 0);
  println("move mouse and click at successive interesting points");
}

void draw() {
}

float prevMouseX = -77;
float prevMouseY = -77;
float prevTheta  = 0;

float mynf(float x){
      //get rid of too many decimals
      return float(int(100*x))/100;
}

void mouseClicked() {
     if (prevMouseX == -77 && prevMouseY == -77) {
         prevMouseX = mouseX; prevMouseY = mouseY; println("//let's begin..");
         o.setPos(mouseX,mouseY);
     }
     else {
         float dx = mouseX - prevMouseX;
         float dy = mouseY - prevMouseY;
         float forwd  = sqrt(dx*dx + dy*dy);
         float theta = (atan2(-dy,dx) * 180)/PI;
         float dTheta = theta - prevTheta;
         if (dTheta < -240) dTheta += 360;
         if (dTheta >  240) dTheta -= 360;
         print("o.left(");print(mynf(dTheta));println(");");
         print("o.forward(");print(mynf(forwd));println(");");
         prevMouseX = mouseX; prevMouseY = mouseY;prevTheta = theta;
         o.left(dTheta);
         o.forward(forwd);
     }
}


